--- a/lib/number.vala	Fri Jan 29 16:44:36 2016
+++ b/lib/number.vala	Mon Feb  1 12:02:40 2016
@@ -716,41 +1072,23 @@
     /* Sets z = x + y */
     public Number add (Number y)
     {
-        if (is_complex () || y.is_complex ())
-        {
-            Number real_z, im_z;
-
-            var real_x = real_component ();
-            var im_x = imaginary_component ();
-            var real_y = y.real_component ();
-            var im_y = y.imaginary_component ();
-
-            real_z = real_x.add_real (real_y);
-            im_z = im_x.add_real (im_y);
-
-            return new Number.complex (real_z, im_z);
-        }
-        else
-            return add_real (y);
+        return add_with_sign (1, y);
     }
 
-    public Number add_real (Number y)
-    {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.add (re_num, y.re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        return z;
-    }
-
     /* Sets z = x − y */
     public Number subtract (Number y)
     {
-        return add (y.invert_sign ());
+        return add_with_sign (-1, y);
     }
 
     /* Sets z = x × y */
     public Number multiply (Number y)
     {
+        /* x*0 = 0*y = 0 */
+        if (is_zero () || y.is_zero ())
+            return new Number.integer (0);
+
+        /* (a+bi)(c+di) = (ac-bd)+(ad+bc)i */
         if (is_complex () || y.is_complex ())
         {
             Number t1, t2, real_z, im_z;
@@ -774,23 +1112,17 @@
             return multiply_real (y);
     }
 
-    public Number multiply_real (Number y)
-    {
-        var z = new Number.integer (0);
-        var tmp = z.re_num;
-        tmp.multiply (re_num, y.re_num, Round.NEAREST);
-        z.re_num = tmp;
-        return z;
-    }
-
     /* Sets z = x × y */
     public Number multiply_integer (int64 y)
     {
-        var z = new Number.integer (0);
-        var tmp = z.re_num;
-        tmp.multiply_signed_integer (re_num, (long) y, Round.NEAREST);
-        z.re_num = tmp;
-        return z;
+        if (is_complex ())
+        {
+            var re_z = real_component ().multiply_integer_real (y);;
+            var im_z = imaginary_component ().multiply_integer_real (y);
+            return new Number.complex (re_z, im_z);
+        }
+        else
+            return multiply_integer_real (y);
     }
 
     /* Sets z = x ÷ y */
@@ -799,31 +1131,23 @@
         if (y.is_zero ())
         {
             /* Translators: Error displayed attempted to divide by zero */
-            error = _("Division by zero is undefined");
+            mperr (_("Division by zero is undefined"));
             return new Number.integer (0);
         }
+        /* 0/y = 0 */
+        if (is_zero ())
+            return this;
 
-        if (is_complex () || y.is_complex ())
-        {
-            var a = real_component ();
-            var b = imaginary_component ();
-            var c = y.real_component ();
-            var d = y.imaginary_component ();
+        /* z = x × y⁻¹ */
+        /* FIXME: Set re_exponent to zero to avoid overflow in multiply??? */
+        var t = y.reciprocal ();
+        var ie = t.re_exponent;
+        t.re_exponent = 0;
+        var i = t.re_fraction[0];
+        var z = multiply (t);
+        z = z.ext (i, z.re_fraction[0]);
+        z.re_exponent += ie;
 
-            var tmp = a.multiply (c).add (b.multiply (d));
-            var tmp_2 = c.xpowy_integer (2).add (d.xpowy_integer (2));
-            var z_1 = tmp.divide (tmp_2);
-
-            tmp = b.multiply (c).subtract (a.multiply (d));
-            var z_2 = tmp.divide (tmp_2);
-
-            var z = new Number.complex (z_1, z_2);
-            return z;
-        }
-
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.divide (re_num, y.re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
         return z;
     }
 
@@ -830,7 +1154,14 @@
     /* Sets z = x ÷ y */
     public Number divide_integer (int64 y)
     {
-        return divide (new Number.integer (y));
+        if (is_complex ())
+        {
+            var re_z = real_component ().divide_integer_real (y);
+            var im_z = imaginary_component ().divide_integer_real (y);
+            return new Number.complex (re_z, im_z);
+        }
+        else
+            return divide_integer_real (y);
     }
 
     /* Sets z = x mod y */
@@ -839,7 +1170,7 @@
         if (!is_integer () || !y.is_integer ())
         {
             /* Translators: Error displayed when attemping to do a modulus division on non-integer numbers */
-            error = _("Modulus division is only defined for integers");
+            mperr (_("Modulus division is only defined for integers"));
             return new Number.integer (0);
         }
 
@@ -857,7 +1188,7 @@
     /* Sets z = x ^ y mod p */
     public Number modular_exponentiation (Number exp, Number mod)
     {
-        var base_value = copy ();
+        var base_value = this.copy ();
         if (exp.is_negative ())
             base_value = base_value.reciprocal ();
         var exp_value = exp.abs ();
@@ -927,51 +1258,87 @@
     public Number tan (AngleUnit unit = AngleUnit.RADIANS)
     {
         /* Check for undefined values */
-        var x_radians = to_radians (unit);
-        var check = x_radians.subtract (new Number.pi ().divide_integer (2)).divide (new Number.pi ());
-
-        if (check.is_integer ())
+        var cos_x = cos (unit);
+        if (cos_x.is_zero ())
         {
             /* Translators: Error displayed when tangent value is undefined */
-            error = _("Tangent is undefined for angles that are multiples of π (180°) from π∕2 (90°)");
+            mperr (_("Tangent is undefined for angles that are multiples of π (180°) from π∕2 (90°)"));
             return new Number.integer (0);
         }
 
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.tan (x_radians.re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        return z;
+        /* tan (x) = sin (x) / cos (x) */
+        return sin (unit).divide (cos_x);
     }
 
     /* Sets z = sin⁻¹ x */
     public Number asin (AngleUnit unit = AngleUnit.RADIANS)
     {
-        if (compare (new Number.integer (1)) > 0 || compare (new Number.integer (-1)) < 0)
-        {
-            /* Translators: Error displayed when inverse sine value is undefined */
-            error = _("Inverse sine is undefined for values outside [-1, 1]");
+        /* asin⁻¹(0) = 0 */
+        if (is_zero ())
             return new Number.integer (0);
+
+        /* sin⁻¹(x) = tan⁻¹(x / √(1 - x²)), |x| < 1 */
+        if (re_exponent <= 0)
+        {
+            var t1 = new Number.integer (1);
+            var t2 = t1;
+            t1 = t1.subtract (this);
+            t2 = t2.add (this);
+            t2 = t1.multiply (t2);
+            t2 = t2.root (-2);
+            var z = multiply (t2);
+            z = z.atan (unit);
+            return z;
         }
 
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.asin (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        return z.from_radians (unit);
+        /* sin⁻¹(1) = π/2, sin⁻¹(-1) = -π/2 */
+        var t2 = new Number.integer (re_sign);
+        if (equals (t2))
+        {
+            var z = new Number.pi ().divide_integer (2 * t2.re_sign);
+            return z.from_radians (unit);
+        }
+
+        /* Translators: Error displayed when inverse sine value is undefined */
+        mperr (_("Inverse sine is undefined for values outside [-1, 1]"));
+        return new Number.integer (0);
     }
 
     /* Sets z = cos⁻¹ x */
     public Number acos (AngleUnit unit = AngleUnit.RADIANS)
     {
-        if (compare (new Number.integer (1)) > 0 || compare (new Number.integer (-1)) < 0)
+        var pi = new Number.pi ();
+        var t1 = new Number.integer (1);
+        var n1 = new Number.integer (-1);
+
+        Number z;
+        if (compare (t1) > 0 || compare (n1) < 0)
         {
             /* Translators: Error displayed when inverse cosine value is undefined */
-            error = _("Inverse cosine is undefined for values outside [-1, 1]");
-            return new Number.integer (0);
+            mperr (_("Inverse cosine is undefined for values outside [-1, 1]"));
+            z = new Number.integer (0);
         }
+        else if (is_zero ())
+            z = pi.divide_integer (2);
+        else if (equals (t1))
+            z = new Number.integer (0);
+        else if (equals (n1))
+            z = pi;
+        else
+        {
+            /* cos⁻¹(x) = tan⁻¹(√(1 - x²) / x) */
+            Number y;
+            var t2 = multiply (this);
+            t2 = t1.subtract (t2);
+            t2 = t2.sqrt ();
+            t2 = t2.divide (this);
+            y = t2.atan (AngleUnit.RADIANS);
+            if (re_sign > 0)
+                z = y;
+            else
+                z = y.add (pi);
+        }
 
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.acos (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
         return z.from_radians (unit);
     }
 
@@ -978,9 +1345,63 @@
     /* Sets z = tan⁻¹ x */
     public Number atan (AngleUnit unit = AngleUnit.RADIANS)
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.atan (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
+        if (is_zero ())
+            return new Number.integer (0);
+
+        var t2 = this;
+        var rx = 0f;
+        if (re_exponent.abs () <= 2)
+            rx = to_float ();
+
+        /* REDUCE ARGUMENT IF NECESSARY BEFORE USING SERIES */
+        var q = 1;
+        Number z;
+        while (t2.re_exponent >= 0)
+        {
+            if (t2.re_exponent == 0 && 2 * (t2.re_fraction[0] + 1) <= BASE)
+                break;
+
+            q *= 2;
+
+            /* t = t / (√(t² + 1) + 1) */
+            z = t2.multiply (t2);
+            z = z.add (new Number.integer (1));
+            z = z.sqrt ();
+            z = z.add (new Number.integer (1));
+            t2 = t2.divide (z);
+        }
+
+        /* USE POWER SERIES NOW ARGUMENT IN (-0.5, 0.5) */
+        z = t2;
+        var t1 = t2.multiply (t2);
+
+        /* SERIES LOOP.  REDUCE T IF POSSIBLE. */
+        for (var i = 1; ; i += 2)
+        {
+            if (T + 2 + t2.re_exponent <= 1)
+                break;
+
+            t2 = t2.multiply (t1).multiply_integer (-i).divide_integer (i + 2);
+
+            z = z.add (t2);
+            if (t2.is_zero ())
+                break;
+        }
+
+        /* CORRECT FOR ARGUMENT REDUCTION */
+        z = z.multiply_integer (q);
+
+        /*  CHECK THAT RELATIVE ERROR LESS THAN 0.01 UNLESS re_exponent
+         *  OF X IS LARGE (WHEN ATAN MIGHT NOT WORK)
+         */
+        if (re_exponent.abs () <= 2)
+        {
+            float ry = z.to_float ();
+            /* THE FOLLOWING MESSAGE MAY INDICATE THAT B**(T-1) IS TOO SMALL. */
+            if (Math.fabs (ry - Math.atan (rx)) >= Math.fabs (ry) * 0.01)
+                mperr ("*** ERROR OCCURRED IN ATAN, RESULT INCORRECT ***");
+        }
+
         return z.from_radians (unit);
     }
 
@@ -987,27 +1408,88 @@
     /* Sets z = sinh x */
     public Number sinh ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.sinh (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        return z;
+        /* sinh (0) = 0 */
+        if (is_zero ())
+            return new Number.integer (0);
+
+        /* WORK WITH ABS (X) */
+        var abs_x = abs ();
+
+        /* If |x| < 1 USE EXP TO AVOID CANCELLATION, otherwise IF TOO LARGE EPOWY GIVES ERROR MESSAGE */
+        Number z;
+        if (abs_x.re_exponent <= 0)
+        {
+            /* ((e^|x| + 1) * (e^|x| - 1)) / e^|x| */
+            // FIXME: Solves to e^|x| - e^-|x|, why not lower branch always? */
+            var exp_x = abs_x.epowy ();
+            var a = exp_x.add (new Number.integer (1));
+            var b = exp_x.add (new Number.integer (-1));
+            z = a.multiply (b);
+            z = z.divide (exp_x);
+        }
+        else
+        {
+            /* e^|x| - e^-|x| */
+            var exp_x = abs_x.epowy ();
+            z = exp_x.reciprocal ();
+            z = exp_x.subtract (z);
+        }
+
+        /* DIVIDE BY TWO AND RESTORE re_sign */
+        z = z.divide_integer (2);
+        return z.multiply_integer (re_sign);
     }
 
     /* Sets z = cosh x */
     public Number cosh ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.cosh (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        return z;
+        /* cosh (0) = 1 */
+        if (is_zero ())
+            return new Number.integer (1);
+
+        /* cosh (x) = (e^x + e^-x) / 2 */
+        var t = abs ();
+        t = t.epowy ();
+        var z = t.reciprocal ();
+        z = t.add (z);
+        return z.divide_integer (2);
     }
 
     /* Sets z = tanh x */
     public Number tanh ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.tanh (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
+        /* tanh (0) = 0 */
+        if (is_zero ())
+            return new Number.integer (0);
+
+        var t = abs ();
+
+        /* SEE IF ABS (X) SO LARGE THAT RESULT IS +-1 */
+        var r__1 = (float) T * 0.5 * Math.log ((float) BASE);
+        var z = new Number.double (r__1);
+        if (t.compare (z) > 0)
+            return new Number.integer (re_sign);
+
+        /* If |x| >= 1/2 use ?, otherwise use ? to avoid cancellation */
+        /* |tanh (x)| = (e^|2x| - 1) / (e^|2x| + 1) */
+        t = t.multiply_integer (2);
+        if (t.re_exponent > 0)
+        {
+            t = t.epowy ();
+            z = t.add (new Number.integer (-1));
+            t = t.add (new Number.integer (1));
+            z = z.divide (t);
+        }
+        else
+        {
+            t = t.epowy ();
+            z = t.add (new Number.integer (1));
+            t = t.add (new Number.integer (-1));
+            z = t.divide (z);
+        }
+
+        /* Restore re_sign */
+        z.re_sign = re_sign * z.re_sign;
         return z;
     }
 
@@ -1014,10 +1496,12 @@
     /* Sets z = sinh⁻¹ x */
     public Number asinh ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.asinh (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        return z;
+        /* sinh⁻¹(x) = ln (x + √(x² + 1)) */
+        var t = multiply (this);
+        t = t.add (new Number.integer (1));
+        t = t.sqrt ();
+        t = add (t);
+        return t.ln ();
     }
 
     /* Sets z = cosh⁻¹ x */
@@ -1028,14 +1512,16 @@
         if (compare (t) < 0)
         {
             /* Translators: Error displayed when inverse hyperbolic cosine value is undefined */
-            error = _("Inverse hyperbolic cosine is undefined for values less than one");
+            mperr (_("Inverse hyperbolic cosine is undefined for values less than one"));
             return new Number.integer (0);
         }
 
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.acosh (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        return z;
+        /* cosh⁻¹(x) = ln (x + √(x² - 1)) */
+        t = multiply (this);
+        t = t.add (new Number.integer (-1));
+        t = t.sqrt ();
+        t = add (t);
+        return t.ln ();
     }
 
     /* Sets z = tanh⁻¹ x */
@@ -1045,14 +1531,17 @@
         if (compare (new Number.integer (1)) >= 0 || compare (new Number.integer (-1)) <= 0)
         {
             /* Translators: Error displayed when inverse hyperbolic tangent value is undefined */
-            error = _("Inverse hyperbolic tangent is undefined for values outside [-1, 1]");
+            mperr (_("Inverse hyperbolic tangent is undefined for values outside [-1, 1]"));
             return new Number.integer (0);
         }
 
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.atanh (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        return z;
+        /* atanh (x) = 0.5 * ln ((1 + x) / (1 - x)) */
+        var n = add (new Number.integer (1));
+        var d = invert_sign ();
+        d = d.add (new Number.integer (1));
+        var z = n.divide (d);
+        z = z.ln ();
+        return z.divide_integer (2);
     }
 
     /* Sets z = boolean AND for each bit in x and z */
@@ -1062,7 +1551,7 @@
         is_positive_integer () || !y.is_positive_integer ())
         {
             /* Translators: Error displayed when boolean AND attempted on non-integer values */
-            error = _("Boolean AND is only defined for positive integers");
+            mperr (_("Boolean AND is only defined for positive integers"));
         }
 
         return bitwise (y, (v1, v2) => { return v1 & v2; }, 0);
@@ -1074,7 +1563,7 @@
         if (!is_positive_integer () || !y.is_positive_integer ())
         {
             /* Translators: Error displayed when boolean OR attempted on non-integer values */
-            error = _("Boolean OR is only defined for positive integers");
+            mperr (_("Boolean OR is only defined for positive integers"));
         }
 
         return bitwise (y, (v1, v2) => { return v1 | v2; }, 0);
@@ -1086,7 +1575,7 @@
         if (!is_positive_integer () || !y.is_positive_integer ())
         {
             /* Translators: Error displayed when boolean XOR attempted on non-integer values */
-            error = _("Boolean XOR is only defined for positive integers");
+            mperr (_("Boolean XOR is only defined for positive integers"));
         }
 
         return bitwise (y, (v1, v2) => { return v1 ^ v2; }, 0);
@@ -1098,7 +1587,7 @@
         if (!is_positive_integer ())
         {
             /* Translators: Error displayed when boolean XOR attempted on non-integer values */
-            error = _("Boolean NOT is only defined for positive integers");
+            mperr (_("Boolean NOT is only defined for positive integers"));
         }
 
         return bitwise (new Number.integer (0), (v1, v2) => { return v1 ^ 0xF; }, wordlen);
@@ -1121,7 +1610,7 @@
         if (!is_integer ())
         {
             /* Translators: Error displayed when bit shift attempted on non-integer values */
-            error = _("Shift is only possible on integer values");
+            mperr (_("Shift is only possible on integer values"));
             return new Number.integer (0);
         }
 
